
# q-expansion of newform 258.2.a.f, downloaded from the LMFDB on 25 April 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 258
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[1], [1], [-1], [1], [5], [-7], [4], [-1], [-4], [-5], [-10], [10], [0], [1], [-1], [12], [4], [-8], [-2], [-12], [4], [10], [-7], [6], [-7], [18], [6], [3], [5], [9], [16], [6], [-9], [-14], [10], [-16], [18], [3], [7], [6], [-16], [7], [-18], [-2], [2], [4], [-5], [7], [18], [-22], [-25], [-5], [-10], [-21], [-15], [-2], [4], [-8], [-30], [30], [4], [0], [28], [-31], [-8], [24], [17], [-5], [12], [-28], [4], [24], [-10], [10], [-12], [-36], [5], [-1], [38], [32], [28], [16], [19], [14], [-22], [-39], [-19], [10], [-14], [23], [6], [11], [12], [30], [-25], [-28], [20], [-31], [-1], [10], [-12], [12], [4], [-18], [-23], [-38], [0], [-22], [19], [42], [-1], [-2], [16], [-10], [-40], [-30], [42], [-10], [17], [-12], [11], [16], [34], [12], [20], [16], [17], [20], [-7], [-36], [-51], [30], [-25], [30], [6], [-21], [-45], [46], [42], [-30], [-28], [24], [-16], [23], [-38], [-14], [-21], [18], [-15], [10], [38], [28], [2], [-22], [-44], [-54], [-46], [27], [-28], [46], [-53], [9], [-54], [-36], [-16], [18], [-23], [-10]]
